/*
 * (C) 2003 by Chaskiel Grundman <cg2v@andrew.cmu.edu>
 * (C) 2003 by Philip Edelbrock <phil@netroedge.com>
 * Copyright (c) 2008 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Significantly based on the alladin etoken driver:
 * (C) 2002 by Andreas Jellinghaus <aj@dungeon.inka.de>
 * (C) 2002 by Olaf Kirch <okir@caldera.de>
 * 
 * See the file LICENSE for use and distribution information.
 */

/* $Id */

#ifndef _ETOKEN_H
#define _ETOKEN_H

#include <sys/types.h>

#define MAX_READER_NUM 16
struct egate {
  struct usb_dev_handle *usb;
  int reader_id;
  int atrlen;
  char atr[256];
  char stat;
};

/* egate.c */
extern int egate_probe(struct egate *egate, int myVendor, int myProduct,
                       int (*isthistheone)(void *rock, char *dir, char *file),
                       void *rock);
extern void egate_release(struct egate *egate);
extern int power_up_egate(struct egate *egate);
extern void power_down_egate(struct egate *egate);

extern void hexdump(const u_int8_t * data, int length);
extern int usb_transfer(struct egate *egate, u_int8_t * buffer_out,
                        u_int8_t * buffer_in, int len_out, int *len_int);

#endif /* _ETOKEN_H */
